import java.util.ArrayList;

/**
 * 
 * @author Lorenz Schauer
 * 
 * Klasse Student aus dem Javakurs vom 18.01.2018
 * Attribute: Name, Matrikelnummer und Notenliste
 * Methoden: Getter, Noten hinzufgen und Durchschnitt berechnen
 * 
 * Zudem enthlt die Klasse nun einen Instanzzhler, sowie einen Getter dafr.
 * Die Instanzvariable matrikelnr ist nun als final deklariert und somit nur einmal beschreibbar. Der Wert kann danach nicht mehr verndert werden.
 * 
 *
 */
public class Student {
	
	private static int instances;

	// Deklaration der Instanzvariablen
	private String name; 
	private final int matrikelnr;
	private ArrayList<Double> notenliste;
	
	// Konstruktor
	public Student(String name, int matrikelnr){
		
		this.name=name;
		this.matrikelnr = matrikelnr;	
		this.notenliste = new ArrayList<Double>();
		
		instances++;
		
	}

	// Fgt Note zur Liste hinzu
	public void addNote(double note){
		
		notenliste.add(note);
		
	}
	
	//Berechnet Durchschnitt auf den eingetragenen Noten und gibt diesen zurck
	public double calcMittelwert(){
		
		if(notenliste.size()==0)
			return 0.0;
		
		double summe = 0.0;
		for(double i : notenliste)
			summe+=i;
		
		return summe/notenliste.size();		
	}
	
	// Zur ausgabe der Gre:	
	public int getAnzahlNoten(){
		return this.notenliste.size();
	}

	//******************
	// Getter-Methoden
	//******************
	
	public String getName() {
		return name;
	}

	public int getMatrikelnr() {
		return matrikelnr;
	}

	public ArrayList<Double> getNotenliste() {
		return notenliste;
	}
	
	public static int getInstances(){
		return instances;
	}
	
	
	
}
